
----assemble with TASM /W2 /MX emssubr -------------------------------
                PAGE ,132
                TITLE Expanded Memory Access Routines

		.MODEL	LARGE,C

                PUBLIC  ems_err
                PUBLIC  ems_verify
                PUBLIC  ems_alloc
                PUBLIC  ems_map
                PUBLIC  ems_free
                PUBLIC  ems_getframe
                PUBLIC  ems_pagecnt

		LOCALS	LL

                .DATA

emname		db	'EMMXXXX0'	; name of ems driver

ems_err		dw	0

                .CODE

                SUBTTL ems_verify
                PAGE +

ems_verify	PROC	uses DS SI DI
		mov	ax, DGROUP
		mov	ds, ax

		mov	ax, 0  		; check if int vect 67 set up
		mov	es, ax
		mov	ax, es:[4*67h+2]
		or	ax, ax		; segment non zero ?
		jz	LL01		; if not
		mov	es, ax

		mov	di, 10		; offset to driver name
		mov	si, offset emname
		mov	cx, 8
		cld
		rep	cmpsb		; check driver name
		jne	LL01

		mov	ax, 1
		jmp	short LL02

LL01:		mov	ax, 0ffh	; no driver code
		mov	[ems_err], ax
		xor	ax, ax		; zero ret code = bad
		
LL02:		ret

ems_verify	ENDP
	

                SUBTTL ems_alloc
                PAGE +

ems_alloc	PROC	uses DS
		arg	pgcnt:word
		mov	ax, DGROUP
		mov	ds, ax

                mov	bx, [pgcnt]	; get number of pages to allocate
                mov	ah, 43H		; allocate space
                int	67H
                mov	byte ptr [ems_err], ah
                or	ah, ah		; ah is zero if call succeeded
                jnz	LL01
		mov	ax, dx		; return handle
                jmp	short LL02
LL01:
                xor	ax, ax
LL02:
                ret
ems_alloc	ENDP

                SUBTTL ems_map
                PAGE +

ems_map		PROC	uses DS
		arg	phys:word,handle:word,lpage:word
		mov	ax, DGROUP
		mov	ds, ax

		mov	ax, [phys]	; get phys page slot
		mov	dx, [handle]	; get handle number
		mov	bx, [lpage]	; get logical page number
                mov	ah, 44H		; map page
                int	67H
                mov	byte ptr [ems_err], ah
                or	ah, ah		; see if ok
                jnz	LL01

                mov	ax, 1
                jmp	short LL02
LL01:
                xor	ax, ax
LL02:
                ret
ems_map		ENDP
                
                SUBTTL ems_free
                PAGE +

ems_free	PROC
		arg	handle:word

                mov	dx, [handle]
                mov	ah, 45H
                int	67H
		xor	ax, ax

                ret
ems_free	ENDP

                SUBTTL ems_getframe
                PAGE +

ems_getframe	PROC	uses DS		; sets AX to EMS page frame
		mov	ax, DGROUP
		mov	ds, ax

                mov	ah, 41H		; get frame seq
                int	67H
                mov	byte ptr [ems_err], ah
                or	ah, ah		; ah is zero if call succeeded
                jnz	LL01
                mov	ax, bx		; return page frame in ax
                jmp	short LL02
LL01:
                xor	ax, ax
LL02:
                ret
ems_getframe	ENDP

                SUBTTL ems_pagecnt
                PAGE +

ems_pagecnt	PROC	uses DS		; sets AX to EMS page frame
		mov	ax, DGROUP
		mov	ds, ax

                mov	ah, 42H		; get ems page count
                int	67H
                mov	byte ptr [ems_err], ah
                or	ah, ah		; see if ok
                jnz	LL01

                mov	ax, bx		; return page count
                jmp	short LL02
LL01:
                xor	ax, ax
LL02:
                ret
ems_pagecnt	ENDP

                END
