
/*
 * Emstbl -- EMS Table Routines
 */

#include <dos.h>
#include <mem.h>
#include <alloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "etbl.h"

static int eseg;						/* EMS Segment Address */

extern int ems_err;

int far etinit(e)
struct etbl far *e;
{
	int i;

	if (ems_verify() == 0)
		err("No EMS driver found");

	eseg = ems_getframe();
	e->e_ecpf = 16384 / e->e_elen;
	e->e_pgs = (e->e_ecnt + e->e_ecpf - 1) / e->e_ecpf;
	e->e_ecnt = e->e_pgs * e->e_ecpf;

	if ((e->e_hand = ems_alloc(e->e_pgs)) == 0)
		err("Not enough EMS available");
	for (i = 0; i < e->e_pgs; i++) {
		if (ems_map(e->e_efrm, e->e_hand, i) == 0)
			err("EMS_MAP failed err %02x  handle %04X  page %02X",
				ems_err, e->e_hand, i);
		memset(MK_FP(eseg, (e->e_efrm << 14)), 0, 16384);
	}

	e->e_ecur = 0;
	return(0);
}

void far * far etmap(e, ndx)
struct etbl far *e;
int ndx;
{
	int i, j, pg;
	j = ndx - 1;
	i = j / e->e_ecpf;
	j = j % e->e_ecpf;
	pg = e->e_efrm;
	if (ems_map(pg, e->e_hand, i) == 0)
		err("EMS_MAP failed err %02x  handle %04X  page %02X",
			ems_err, e->e_hand, i);
	return(MK_FP((eseg + (pg << 10)), (j * e->e_elen)));
}

void far etclose(e)
struct etbl far *e;
{
	ems_free(e->e_hand);
	e->e_elen = e->e_ecur = e->e_ecnt = e->e_hand = 0;
}

